#!/usr/bin/perl

require './web-lib.pl';
&init_config();
$hostname = &get_system_hostname();
$ver = &get_webmin_version();
&get_miniserv_config(\%miniserv);
if ($gconfig{'real_os_type'}) {
	$ostr = "$gconfig{'real_os_type'} $gconfig{'real_os_version'}";
	}
else {
	$ostr = "$gconfig{'os_type'} $gconfig{'os_version'}";
	}

if ($gconfig{'alt_startpage'}) {
	# Tim's webmin header
	&header(&text('main_title', $ver, $hostname, $ostr));
	print "<TABLE BORDER=0 WIDTH=100%>\n";
	print "<TR><TD WIDTH=20% ALIGN=left>\n";
	print "Version $ver<BR>$hostname<BR>$ostr</TD>";
	print "<TD WIDTH=60% ALIGN=center>\n";
	print "<IMG SRC=\"images/webmin.gif\" BORDER=0";
	print "</TD><TD WIDTH=20% ALIGN=right>";
	print "<a href=http://www.webmin.com/>$text{'main_homepage'}</a><br>";
	print "<a href=mailto:jcameron\@webmin.com>$text{'main_feedback'}</a>";
	if ($miniserv{'logout'}) {
		print "<br><br>\n";
		print "<a href=logout.cgi>$text{'main_switch'}</a>";
		}
	print "</TD></TR></TABLE><HR><P>\n\n";
	}
else {
	# Standard webmin header
	&header(&text('main_title', $ver, $hostname, $ostr),
		"images/webmin.gif", undef, undef, 1, 1,
		$gconfig{'brand'} ? $gconfig{'brand'} :
		"<a href=http://www.webmin.com/>$text{'main_homepage'}</a><br>".
		"<a href=mailto:jcameron\@webmin.com>$text{'main_feedback'}</a>"
		);
	print "<center><font size=+1>",
	    &text('main_version', $ver, $hostname, $ostr),"</font></center>\n";
	print "<hr><p>\n";
	}

# Build a list of all modules
&read_acl(\%acl);
opendir(DIR, ".");
$user = $ENV{'REMOTE_USER'};
foreach $d (readdir(DIR)) {
	local %minfo;
	if (%minfo = &get_module_info($d)) {
		if (!&check_os_support(\%minfo)) {
			# This OS is not supported!
			next;
			}
		if (!$acl{$user,$d} && !$acl{$user,"*"}) {
			# This user has no access
			next;
			}
		push(@modules, \%minfo);
		}
	}
closedir(DIR);
@modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;

if ($gconfig{"notabs_$user"} == 2 ||
    $gconfig{"notabs_$user"} == 0 && $gconfig{'notabs'}) {
	# Generate main menu with all modules on one page
	print "<center><table cellpadding=5>\n";
	$pos = 0;
	$cols = $gconfig{'nocols'} ? $gconfig{'nocols'} : 4;
	$per = 100.0 / $cols;
	foreach $m (@modules) {
		if ($pos % $cols == 0) { print "<tr>\n"; }
		print "<td valign=top align=center width=$per\%>\n";
		print "<table border><tr><td><a href=/$m->{'dir'}/>",
		      "<img src=$m->{'dir'}/images/icon.gif border=0></a>",
		      "</td></tr></table>\n";
		print "<a href=/$m->{'dir'}/>$m->{'desc'}</a></td>\n";
		if ($pos % $cols == $cols - 1) { print "</tr>\n"; }
		$pos++;
		}
	print "</table></center><p><hr>\n";
	}
else {
	# Display under categorised tabs
	&ReadParse();
	@cats = sort { $b cmp $a } &unique(map { $_->{'category'} } @modules);
	$cats = @cats;
	$per = 100.0 / $cats;
	if (!defined($in{'cat'})) {
		$in{'cat'} = $cats[0];
		}
	print "<table border=0 cellpadding=0 cellspacing=0 height=20><tr>\n";
	foreach $c (@cats) {
		$t = $text{"category_$c"};
		if ($in{'cat'} eq $c) {
			print "<td valign=top $cb>",
			      "<img src=images/lc2.gif></td>\n";
			print "<td $cb>&nbsp;<b>$t</b>&nbsp;</td>\n";
			print "<td valign=top $cb>",
			      "<img src=images/rc2.gif></td>\n";
			}
		else {
			print "<td valign=top $tb>",
			      "<img src=images/lc1.gif></td>\n";
			print "<td $tb>&nbsp;",
			      "<a href=/?cat=$c><b>$t</b></a>&nbsp;</td>\n";
			print "<td valign=top $tb>",
			      "<img src=images/rc1.gif></td>\n";
			}
		print "<td width=10></td>\n";
		}
	print "</tr></table> <table border=0 cellpadding=0 cellspacing=0 ",
              "width=100% $cb>\n";
	print "<tr><td><table width=100% cellpadding=5>\n";

	# Display the modules in this category
	$pos = 0;
	$cols = $gconfig{'nocols'} ? $gconfig{'nocols'} : 4;
	$per = 100.0 / $cols;
	foreach $m (@modules) {
		next if ($m->{'category'} ne $in{'cat'});

		if ($pos % $cols == 0) { print "<tr>\n"; }
		print "<td valign=top align=center width=$per\%>\n";
		print "<table border bgcolor=#ffffff><tr><td><a href=/$m->{'dir'}/>",
		      "<img src=$m->{'dir'}/images/icon.gif border=0></a>",
		      "</td></tr></table>\n";
		print "<a href=/$m->{'dir'}/>$m->{'desc'}</a></td>\n";
		if ($pos++ % $cols == $cols - 1) { print "</tr>\n"; }
		}
	while($pos++ % $cols) {
		print "<td width=$per\%></td>\n";
		}
	print "</table></td></tr></table><p><hr>\n";
	}

if ($miniserv{'logout'} && !$gconfig{'alt_startpage'}) {
	print "<div align=right><a href=logout.cgi>$text{'main_switch'}</a>",
	      "</div><br>\n";
	}

