#!/usr/bin/perl
# edit_cache.cgi
# A form for editing cache options

require './squid-lib.pl';
&header("Cache Options", "", undef, 0, 0, 0, &restart_button());
print "<hr>\n";
$conf = &get_config();

print "<form action=save_cache.cgi>\n";
print "<table border width=100%>\n";
print "<tr $tb> <td><b>Caching and Request Options</b></td> </tr>\n";
print "<tr $cb> <td><table width=100%>\n";

print "<tr>\n";
@dirs = &find_config("cache_dir", $conf);
print "<td valign=top><b>Cache directories</b></td> <td colspan=3>\n";
printf "<input type=radio name=cache_dir_def value=1 %s>Default\n",
	@dirs ? "" : "checked";
printf "<input type=radio name=cache_dir_def value=0 %s>Listed..<br>\n",
	@dirs ? "checked" : "";
print "<table border>\n";
if ($squid_version >= 2) {
	print "<tr $tb> <td><b>Directory</b></td>\n";
	if ($squid_version >= 2.3) {
		print "<td><b>Type</b></td>\n";
		}
	print "<td><b>Size (Mb)</b></td>\n";
	print "<td><b>1st level dirs</b></td>\n";
	print "<td><b>2nd level dirs</b></td> </tr>\n";
	}
for($i=0; $i<=@dirs; $i++) {
	@dv = $i<@dirs ? @{$dirs[$i]->{'values'}} : ();
	print "<tr $cb>\n";
	if ($squid_version >= 2.3) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$dv[1]\"></td>\n";
		print "<td><select name=cache_type_$i>\n";
		printf "<option value=ufs %s>UFS\n",
			$dv[0] eq 'ufs' ? 'selected' : '';
		printf "<option value=asyncufs %s>Async UFS\n",
			$dv[0] eq 'asyncufs' ? 'selected' : '';
		print "</select></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$dv[2]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$dv[3]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$dv[4]\"></td>\n";
		}
	elsif ($squid_version >= 2) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$dv[0]\"></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$dv[1]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$dv[2]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$dv[3]\"></td>\n";
		}
	else {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$dv[0]\"></td>\n";
		}
	print "</tr>\n";
	}
print "</table></td> </tr>\n";

if ($squid_version < 2) {
	print "<tr>\n";
	print &opt_input("First level directories", "swap_level1_dirs", $conf,
			 "Default", 6);
	print &opt_input("Second level directories", "swap_level2_dirs", $conf,
			 "Default", 6);
	print "</tr>\n";
	}

print "<tr>\n";
if ($squid_version < 2) {
	print &opt_input("Average object size", "store_avg_object_size", $conf,
			 "Default", 6, "Kb");
	}
else {
	print &opt_bytes_input("Average object size", "store_avg_object_size",
			       $conf, "Default", 6);
	}
print &opt_input("Objects per bucket", "store_objects_per_bucket", $conf,
		 "Default", 6);
print "</tr>\n";

if ($squid_version < 2) {
	print "<tr>\n";
	print &list_input("Don't cache URLs containing", "cache_stoplist",
			  $conf, 1, "Default");
	print "</tr>\n";

	print "<tr>\n";
	print &list_input("Don't cache URLs matching", "cache_stoplist_pattern",
			  $conf, 1, "Default");
	print "</tr>\n";
	}
print "<tr> <td valign=top><b>Don't cache URLs for ACLs</b></td> <td>\n";
@acls = &find_config("acl", $conf);
@v = &find_config("no_cache", $conf);
foreach $v (@v) {
	foreach $ncv (@{$v->{'values'}}) {
		$noca{$ncv}++;
		}
	}
foreach $acl (@acls) {
	$aclv = $acl->{'values'}->[0];
	printf "<input type=checkbox name=no_cache value=$aclv %s>$aclv\n",
		$noca{$aclv} ? "checked" : "";
	}
print "</td>\n";
print &opt_time_input("Maximum cache time", "reference_age", $conf,
		      "Default", 6);
print "</tr>\n";

print "<tr>\n";
if ($squid_version >= 2) {
	if ($squid_version >= 2.3) {
		print &opt_bytes_input("Maximum request body size",
			"request_body_max_size", $conf, "Default", 6);
		print &opt_bytes_input("Maximum request headers size",
			"request_header_max_size", $conf, "Default", 6);
		print "</tr>\n";

		print "<tr>\n";
		print &opt_bytes_input("Maximum reply body size",
			"reply_body_max_size", $conf, "Default", 6);
		}
	else {
		print &opt_bytes_input("Maximum request size", "request_size",
				       $conf, "Default", 6);
		}
	print &opt_time_input("Failed request cache time",
			      "negative_ttl", $conf, "Default", 4);
	}
else {
	print &opt_input("Maximum request size", "request_size", $conf,
			 "Default", 8, "Kb");
	print &opt_input("Failed request cache time", "negative_ttl", $conf,
			 "Default", 4, "mins");
	}
print "</tr>\n";

print "<tr>\n";
if ($squid_version < 2) {
	print &opt_input("DNS lookup cache time", "positive_dns_ttl", $conf,
			 "Default", 4, "mins");
	print &opt_input("Failed DNS cache time", "negative_dns_ttl", $conf,
			 "Default", 4, "mins");
	}
else {
	print &opt_time_input("DNS lookup cache time", "positive_dns_ttl",
			      $conf, "Default", 4);
	print &opt_time_input("Failed DNS cache time", "negative_dns_ttl",
			      $conf, "Default", 4);
	}
print "</tr>\n";

if ($squid_version < 2) {
	print "<tr>\n";
	print &opt_input("Connect timeout", "connect_timeout", $conf,
			 "Default", 4, "secs");
	print &opt_input("Read timeout", "read_timeout", $conf,
			 "Default", 4, "secs");
	print "</tr>\n";

	print "<tr>\n";
	print &opt_input("Max client connect time", "client_lifetime", $conf,
			 "Default", 4, "mins");
	print &opt_input("Max shutdown time", "shutdown_lifetime", $conf,
			 "Default", 4, "mins");
	print "</tr>\n";
	}
else {
	print "<tr>\n";
	print &opt_time_input("Connect timeout", "connect_timeout", $conf,
			      "Default", 4);
	print &opt_time_input("Read timeout", "read_timeout", $conf,
			      "Default", 4);
	print "<tr>\n";

	print "</tr>\n";
	print &opt_time_input("Site selection timeout", "siteselect_timeout",
			      $conf, "Default", 4);
	print &opt_time_input("Client request timeout", "request_timeout",
			      $conf, "Default", 4);
	print "</tr>\n";

	print "<tr>\n";
	print &opt_time_input("Max client connect time", "client_lifetime",
			      $conf, "Default", 4);
	print &opt_time_input("Max shutdown time", "shutdown_lifetime",
			      $conf, "Default", 4);
	print "</tr>\n";

	print "<tr>\n";
	print &choice_input("Half-closed clients?", "half_closed_clients",
			    $conf, "on", "On", "on", "Off", "off");
	print &opt_time_input("Persistant timeout", "pconn_timeout",
			      $conf, "Default", 4);
	print "</tr>\n";
	}

if ($squid_version < 2) {
	print "<tr> <td><b>WAIS relay</b></td> <td colspan=3>\n";
	$v = &find_config("wais_relay", $conf);
	printf "<input type=radio name=wais_relay_def value=1 %s> None\n",
		$v ? "" : "checked";
	printf "<input type=radio name=wais_relay_def value=0 %s> Host\n",
		$v ? "checked" : "";
	@wrv = $v ? @{$v->{'values'}} : ();
	print "<input size=20 name=wais_relay1 value=\"$wrv[0]\">&nbsp;Port\n";
	print "<input size=6 name=wais_relay2 value=\"$wrv[1]\"></td>\n";
	print "</tr>\n";
	}
else {
	print "<tr>\n";
	print &opt_input("WAIS relay host", "wais_relay_host",
			 $conf, "None", 20);
	print &opt_input("WAIS relay port", "wais_relay_port",
			 $conf, "Default", 6);
	print "</tr>\n";
	}

print "</table></td></tr></table><br>\n";
print "<input type=submit value=Save></form>\n";

print "<hr>\n";
&footer("", "squid index");

