#!/usr/bin/perl
# save_admin.cgi
# Save admin options

require './squid-lib.pl';
&ReadParse();
$conf = &get_config();
$whatfailed = "Failed to save administrative options";

($olduser, $oldgroup) = &get_squid_user($conf);
if ($squid_version < 2) {
	if ($in{'effective_def'}) {
		&save_directive($conf, "cache_effective_user", [ ]);
		}
	else {
		%dir = ( 'name', 'cache_effective_user',
			 'values', [ $in{'effective_u'}, $in{'effective_g'} ] );
		&save_directive($conf, "cache_effective_user", [ \%dir ]);
		}
	}
else {
	&save_opt("cache_effective_user", undef, $conf);
	&save_opt("cache_effective_group", undef, $conf);
        &save_opt("proxy_auth_realm", undef, $conf);
        }
&save_opt("cache_mgr", \&check_email, $conf);
&save_opt("visible_hostname", \&check_hostname, $conf);
if ($squid_version < 2) {
	&save_opt("announce_to", undef, $conf);
	&save_opt("cache_announce", \&check_announce, $conf);
	}
else {
	&save_opt("unique_hostname", \&check_hostname, $conf);
	&save_opt("announce_host", \&check_hostname, $conf);
	&save_opt("announce_port", \&check_port, $conf);
	&save_opt("announce_file", undef, $conf);
	&save_opt_time("announce_period", $conf);
	}
&flush_file_lines();

($user, $group) = &get_squid_user($conf);
if (($olduser ne $user || $oldgroup ne $group) && $user && $group) {
	# User/group has changed! Ask user if he wants to chown log/cache/pid
	&header("Change Ownership", "");
	print "<hr><p>\n";
	print "You have changed the user or group that Squid runs as.\n";
	print "For this to take effect properly, the ownership of all\n";
	print "cache and log files should be updated and Squid re-started.\n";
	print "<center><form action=chown.cgi>\n";
	print "<input type=submit value=\"Change Ownership\">\n";
	print "</form></center>\n";
	print "<hr>\n";
	&footer("", "index");
	}
else { &redirect(""); }

sub check_email
{
return $_[0] =~ /^\S+$/ ? undef : "'$_[0]' is not a valid email address";
}

sub check_hostname
{
return $_[0] =~ /^\S+$/ ? undef : "'$_[0]' is not a valid hostname";
}

sub check_announce
{
return $_[0] =~ /^\d+$/ ? undef : "'$_[0]' is not a valid announcement period";
}

sub check_port
{
return $_[0] =~ /^\d+$/ ? undef : "'$_[0]' is not a valid port";
}

