#!/usr/bin/perl

local $format;
local $out;

require "./time-lib.pl";

&ReadParse();

$in{ 'year' } = substr( $in{ 'year' }, 2, length( $in{ 'year' } ) );

if( $in{ 'action' } eq $text{ 'action_apply' } )
{
  &error( $text{ 'acl_nosys' } ) if( $access{ 'sysdate' } );
  $in{ 'date' } = "0". $in{ 'date' } if( $in{ 'date' } <= 9 );
  $format = $in{ 'month' }. $in{ 'date' }. $in{ 'hour' }. $in{ 'minute' }. $in{ 'year' }. ".". $in{ 'second' };
  `date $format`;

} elsif ( $in{ 'action' } eq $text{ 'action_save' } ) {
  &error( $text{ 'acl_nohw' } ) if( $access{ 'hwdate' } );
  $format = "--set --date=\"". $in{ 'month' }. "/". $in{ 'date' }. "/". $in{ 'year' }. " ". $in{ 'hour' }. ":". $in{ 'minute' }. ":". $in{ 'second' }. "\"";
  $out = `hwclock $format`;
  &error( &text( 'error_hw', $out ) ) if( $out ne "" );

} elsif( $in{ 'action' } eq $text{ 'action_sync' } ) {
  &error( $text{ 'acl_nosys' } ) if( $access{ 'sysdate' } );
  $out = `hwclock --hctosys`;
  &error( &text( 'error_sync', $out ) ) if( $out ne "" );

} elsif( $in{ 'action' } eq $text{ 'action_timeserver_sys' } || $in{ 'action' } eq $text{ 'action_timeserver_hw' } ) {
  &open_socket( $in{ 'timeserver' }, "13", "SOCK" );
  local ( $weekday, $month, $day, $rawtime, $year ) = split( / /, <SOCK> );
  close( SOCK );

  local( $hour, $minute, $seconds ) = split( /:/, $rawtime );
  local %corr_month = ( "Jan", "01", "Feb", "02", "Mar", "03", "Apr", "04", "May", "05", "Jun", "06", "Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12" );

  if( $in{ 'action' } eq $text{ 'action_timeserver_sys' } )
  {
    $format = $corr_mont{ '$month' }. $date. $hour. $minute. $year. ".". $second;
	`date $format`;
  } else {
    $format = "--set --date=\"". $month. "/". $date. "/". $year. " ". $hour. ":". $minute. ":". $second. "\"";
	`hwclock $format`;
  }
}

&redirect( "/time" );
